App Engine Flexible Environment – Dockerfile安装了GDAL的过时版本。

我正试图在Google App Engine Flexible Environment上使用Docker镜像。

FROM ubuntu:bionic
MAINTAINER Makina Corpus "contact@makina-corpus.com"

ENV PYTHONUNBUFFERED 1
ENV DEBIAN_FRONTEND noninteractive
ENV LANG C.UTF-8

RUN apt-get update -qq && apt-get install -y -qq \
    # std libs
    git less nano curl \
    ca-certificates \
    wget build-essential\
    # python basic libs
    python3.8 python3.8-dev python3.8-venv gettext \
    # geodjango
    gdal-bin binutils libproj-dev libgdal-dev \
    # postgresql
    libpq-dev postgresql-client && \
    apt-get clean all && rm -rf /var/apt/lists/* && rm -rf /var/cache/apt/*

# install pip
RUN wget https://bootstrap.pypa.io/get-pip.py && python3.8 get-pip.py && rm get-pip.py
RUN pip3 install --no-cache-dir setuptools wheel -U

CMD ["/bin/bash"]

docker镜像似乎正确构建,但当服务部署时,应用程序崩溃,我得到这个错误信息。

  File "/Users/NAME/Documents/gcp/google-cloud-sdk/lib/googlecloudsdk/api_lib/app/operations_util.py", line 183, in IsDone
    encoding.MessageToPyValue(operation.error)))
OperationError: Error Response: [9] 
Application startup error! Code: APP_CONTAINER_CRASHED

ERROR: (gcloud.app.deploy) Error Response: [9] 
Application startup error! Code: APP_CONTAINER_CRASHED

这是失败的,因为Dockerfile安装了一个明显过时的GDAL包的版本,这与当前的python安装冲突。

我如何确保Dockerfile有正确的包库,并且安装的是正确的、最新的版本?有没有什么行可以让我在开始安装之前插入更新版本库,或者至少打印版本库?

EDIT:

我的app. yaml:

# [START django_app]

runtime: custom
env: flex
entrypoint: gunicorn -b :$PORT MyApplication.wsgi

runtime_config:
  python_version: 3
# [END runtime]

handlers:
# This configures Google App Engine to serve the files in the app's static
# directory.
#- url: /static
#  static_dir: static/
#- url: /MyApplication/static
#  static_dir: MyApplication/static/


# This handler routes all requests not caught above to your main app. It is
# required when static routes are defined, but can be omitted (along with
# the entire handlers section) when there are no static files defined.
- url: /.*
  script: auto
# [END django_app]

resources:
  cpu: 1
  memory_gb: 2
  disk_size_gb: 10

解决方案:

你的App Engine部署失败了,因为它 需要一个服务监听端口8080 并且它无法在云端运行bash。如果你需要调试你的App Engine Flex实例,你需要先在8080端口上获得一个服务。然后启用SSH.

给TA打赏
共{{data.count}}人
人已打赏
未分类

如何在MySQL中加入3个表

2022-9-8 21:38:38

未分类

如何在Rust中对管道式方法调用进行集中式错误处理?

2022-9-8 21:38:40

0 条回复 A文章作者 M管理员
    暂无讨论,说说你的看法吧
个人中心
购物车
优惠劵
今日签到
有新私信 私信列表
搜索